Versions Compared

Key

  • This line was added.
  • This line was removed.
  • Formatting was changed.

There are two types of ActiveX/COM plugins:

...

  1. Create a new C#  or VB.NET project using the Visual Studio project Wizard( **minimum requirement .NET Framework v4.5).
    One can either create Windows Form Application, Console Application or Class Library.

  2. From Solution Explorer, add references of OdaX_x.xx_xx*.dll and ARESC.exe from ARES Commander installation folder.

  3. You can add references by searching PCAD_AC_X and PCAD_DB_X from COM Assemblies.

  4. You can see the available NameSpaces, Class Methods, and Properties in each assembly using Object Browser.

  5. Rename Program.cs to PluginCommands. This will change class Program to class PluginCommands as in the following example.

    Code Block
    languagec#
    themeRDark
    firstline1
    linenumberstrue
    namespace SamplePlugins
    {
    	class PluginCommands
    	{
    		static void Main(string[] args)
    		{
    		}
    	}
    }


  6. There two ways to work with out process:
    • Create a new Instance
    • Attach with already running application

...


  1. To create an Instance of AcadApplication

...

  1. , use PCAD_AC_X.
    This starts ARES Commander directly.

    Code Block
    languagec#
    themeRDark
    firstline1
    linenumberstrue
    using PCAD_AC_X;
    
    namespace SamplePlugins
    {
    	class PluginCommands
    	{
    		static void Main(string[] args)
    		{
    			Application app = new AcadApplication();
    		}
    	}
    }

...

  1. If ARES Commander is already running, use a version dependent or

...

  1. independent ProgIDs as

...

  1. in the following example.
    For Marshal use System.Runtime.InteropServices.

    Code Block
    languagec#
    themeRDark
    firstline1
    linenumberstrue
    using PCAD_AC_X;
    using System.Runtime.InteropServices;
    
    namespace SamplePlugins
    {
    	class PluginCommands
    	{
    		static void Main(string[] args)
    		{
    			AcadApplication app = (PCAD_AC_X.AcadApplication)Marshal.GetActiveObject("PCAD_AC_X.AcadApplication");
    		}
    	}
    }


Accessing  Documents and Active Documents

From the application object

...

you can access collection of documents or active documents and

...

preferences.

...

The following code iterates through the document collection.

Code Block
languagec#
themeRDark
firstline1
linenumberstrue
foreach(AcadDocument Doc in app.Application.Documents)
{
	Console.Writeline("\n" + Doc.Name);
}

...

The following code gets the active document.

Code Block
languagec#
themeRDark
firstline1
linenumberstrue
AcadDocument NewDrawing;
NewDrawing = app.ActiveDocument;

...

The following code accesses the display preferences.

Code Block
languagec#
themeRDark
firstline1
linenumberstrue
IAcadPreferencesDisplay AcadPref;
AcadPref = app.Preferences.Display;
int Size = AcadPref.CursorSize;

...

  • Rest procedure for accessing various ActiveX/COM objects and collections is same.

Migration of AutoCAD® ActiveX PlugIn Application to ARES Commander

...